#include <stdio.h>

#if __clang__
#  define IMPL "Clang"
#elif __TINYC__
#  define IMPL "TCC"
#elif __GNUC__
#  define IMPL "GCC"
#else
#  define IMPL "an unknown C implementation"
#endif

int main(int argc, char *argv[])
{
  int i;

  puts("Hello from " IMPL "!");
  printf("Script = `%s'\n", argv[0]);
  fputs("Arguments = (", stdout);
  for (i = 1; i < argc; i++) {
    if (i > 1) fputs(", ", stdout);
    printf("`%s'", argv[i]);
  }
  putchar(')'); putchar('\n');
  return (0);
}
